const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const comments = sequelize.define(
    'comments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

body: {
        type: DataTypes.TEXT,
      
      

      },

is_edited: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

is_pinned: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

like_count: {
        type: DataTypes.INTEGER,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  comments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity







    db.comments.hasMany(db.reactions, {
      as: 'reactions_comment',
      foreignKey: {
          name: 'commentId',
      },
      constraints: false,
    });








    db.comments.hasMany(db.notifications, {
      as: 'notifications_comment',
      foreignKey: {
          name: 'commentId',
      },
      constraints: false,
    });










    db.comments.hasMany(db.content_moderation_reports, {
      as: 'content_moderation_reports_comment',
      foreignKey: {
          name: 'commentId',
      },
      constraints: false,
    });





//end loop



    db.comments.belongsTo(db.posts, {
      as: 'post',
      foreignKey: {
        name: 'postId',
      },
      constraints: false,
    });

    db.comments.belongsTo(db.users, {
      as: 'author',
      foreignKey: {
        name: 'authorId',
      },
      constraints: false,
    });

    db.comments.belongsTo(db.comments, {
      as: 'parent_comment',
      foreignKey: {
        name: 'parent_commentId',
      },
      constraints: false,
    });




    db.comments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.comments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return comments;
};


